/*** LET OP! wordt nog op drie andere  punten aangeroepen*****
 ** 10.03/ca-post-01                                        **
 ** 10.04/ca-patch-02                                       **
 ** 11.01/ca-post-01                                        **
 *************************************************************/


/*-- vanaf 10.3 komt er 2 locatie argumenten bij :
was    wordt   staat voor
---    -----   ------------              
       1       TERMINAL
       2       CITY_POSTALCODE
 1     3       PORT  
 2     4       COUNTRY        
 3     5       SUB-AREA       
 4     6       AREA           
 5     7       ALL LOCATIONS  
Dus alle locations met 1 ophogen om het weer in sync te laten lopen --*/

/* LLe : Nee Jelle, je kan hier geen includes gebruiken, aangezien
         deze niet uitgeleverd worden.
   JSC : Sorry Lucas....
   LLe : handmatig {CA/include/ca-preprocessor-list.i} geincludeerd d.w.z. copy/paste */
   
/*-- l&d_location_arg --*/                
&GLOBAL-DEFINE terminal                   1
&GLOBAL-DEFINE city_postalcode            2
&GLOBAL-DEFINE port                       3
&GLOBAL-DEFINE country                    4
&GLOBAL-DEFINE sub_area                   5
&GLOBAL-DEFINE area                       6
&GLOBAL-DEFINE all_locations              7
   
/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE 
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-u_tariff.
DISABLE TRIGGERS FOR LOAD OF ca-quotation_item_tariff.
 
DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

ASSIGN cProgram =  THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  =  100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

ASSIGN cTable  = ''
       cAction = 'Counting..' .
DISPLAY {&mydisplay}.
/*****************************************************************************************************
   EVEN TELLEN, niet echt noodzakelijk ..
*****************************************************************************************************/
iTotal = 0.
FOR EACH ca-u_tariff FIELDS () NO-LOCK:
   ASSIGN iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.
FOR EACH ca-quotation_item_tariff FIELDS () NO-LOCK:
   ASSIGN iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

/*****************************************************************************************************
    TARIFFS BIJWERKEN
*****************************************************************************************************/
ASSIGN cTable  = 'ca-u_tariff'
       cAction = 'updating location arguments' .
DISPLAY {&mydisplay}.

/*-- l_&d_location_arg maken deel uit van indexen, dus index afdwingen waar die niet inzit, anders
     doorlopen we alles net zolang totdat er geen wijzigingen meer zijn --*/
ASSIGN iDone = 0.
FOR EACH ca-u_tariff 
         FIELDS(l_location_arg l_locationcode l_portcode l_countrycode l_subareacode l_areacode 
                d_location_arg d_locationcode d_portcode d_countrycode d_subareacode d_areacode) 
         USE-INDEX ca-u_tariff_default
         EXCLUSIVE-LOCK TRANSACTION:
   CASE TRUE:
      WHEN ca-u_tariff.l_locationcode NE '' THEN ASSIGN ca-u_tariff.l_location_arg = {ca/static terminal}.
      WHEN ca-u_tariff.l_portcode     NE '' THEN ASSIGN ca-u_tariff.l_location_arg = {ca/static port}.
      WHEN ca-u_tariff.l_countrycode  NE '' THEN ASSIGN ca-u_tariff.l_location_arg = {ca/static country}.
      WHEN ca-u_tariff.l_subareacode  NE '' THEN ASSIGN ca-u_tariff.l_location_arg = {ca/static sub_area}.
      WHEN ca-u_tariff.l_areacode     NE '' THEN ASSIGN ca-u_tariff.l_location_arg = {ca/static area}.
      OTHERWISE                                  ASSIGN ca-u_tariff.l_location_arg = {ca/static all_locations}.
   END CASE.
   CASE TRUE:
      WHEN ca-u_tariff.d_locationcode NE '' THEN ASSIGN ca-u_tariff.d_location_arg = {ca/static terminal}.
      WHEN ca-u_tariff.d_portcode     NE '' THEN ASSIGN ca-u_tariff.d_location_arg = {ca/static port}.
      WHEN ca-u_tariff.d_countrycode  NE '' THEN ASSIGN ca-u_tariff.d_location_arg = {ca/static country}.
      WHEN ca-u_tariff.d_subareacode  NE '' THEN ASSIGN ca-u_tariff.d_location_arg = {ca/static sub_area}.
      WHEN ca-u_tariff.d_areacode     NE '' THEN ASSIGN ca-u_tariff.d_location_arg = {ca/static area}.
      OTHERWISE                                  ASSIGN ca-u_tariff.d_location_arg = {ca/static all_locations}.
   END CASE.
   ASSIGN iDone = iDone + 1 .
   
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.       
END. /*each ca-u_tariff*/

/*****************************************************************************************************
    QUOTATIONS BIJWERKEN
*****************************************************************************************************/
ASSIGN cTable  = 'ca-quotation_item_tariff'
       cAction = 'updating location arguments'.
DISPLAY {&mydisplay}.

FOR EACH ca-quotation_item_tariff 
         FIELDS(l_location_arg l_locationcode l_portcode l_countrycode l_subareacode l_areacode 
                d_location_arg d_locationcode d_portcode d_countrycode d_subareacode d_areacode) 
         USE-INDEX ca-quotation_item_tariff       
         EXCLUSIVE-LOCK TRANSACTION:
   
   CASE TRUE:
      WHEN ca-quotation_item_tariff.l_locationcode     NE '' THEN ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static terminal}.
      WHEN ca-quotation_item_tariff.fm_city_postalcode NE '' THEN ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static city_postalcode}.
      WHEN ca-quotation_item_tariff.l_portcode         NE '' THEN ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static port}.
      WHEN ca-quotation_item_tariff.l_countrycode      NE '' THEN ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static country}.
      WHEN ca-quotation_item_tariff.l_subareacode      NE '' THEN ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static sub_area}.
      WHEN ca-quotation_item_tariff.l_areacode         NE '' THEN ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static area}.
      OTHERWISE                                                   ASSIGN ca-quotation_item_tariff.l_location_arg = {ca/static all_locations}.
   END CASE.
   CASE TRUE:
      WHEN ca-quotation_item_tariff.d_locationcode     NE '' THEN ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static terminal}.
      WHEN ca-quotation_item_tariff.to_city_postalcode NE '' THEN ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static city_postalcode}.
      WHEN ca-quotation_item_tariff.d_portcode         NE '' THEN ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static port}.
      WHEN ca-quotation_item_tariff.d_countrycode      NE '' THEN ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static country}.
      WHEN ca-quotation_item_tariff.d_subareacode      NE '' THEN ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static sub_area}.
      WHEN ca-quotation_item_tariff.d_areacode         NE '' THEN ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static area}.
      OTHERWISE                                                   ASSIGN ca-quotation_item_tariff.d_location_arg = {ca/static all_locations}.
   END CASE.
   ASSIGN iDone = iDone + 1 .
   
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END. /*each ca-quotation_item_tariff*/

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Create room for terminal locations & citypostalcode locations'.
END. /*transaction*/
